#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include "globals.h"

int main()
{
    int fd;
    char message[BUFFER_SIZE];

    // Create the named pipe (FIFO).
    mkfifo(FIFO_PATH, 0666);

    while (1)
    {
        // First open the FIFO in write-only mode.
        fd = open(FIFO_PATH, O_WRONLY);

        // Read a message from stdin.
        fgets(message, BUFFER_SIZE, stdin);

        // Write the message to the FIFO and close it.
        write(fd, message, strlen(message) + 1);
        close(fd);

        if (strlen(message) <= 1) break;

        // Now open the FIFO in read-only mode
        // and read from it.
        fd = open(FIFO_PATH, O_RDONLY);
        read(fd, message, sizeof(message));
        if (strlen(message) <= 1) break;

        // Print the message from the FIFO and close it.
        printf("Process ReadWrite said: %s\n", message);
        close(fd);
    }

    printf("Process WriteRead done!\n");
    return 0;
}
